"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const oaf_routing_1 = require("oaf-routing");
exports.defaultSettings = Object.assign({}, oaf_routing_1.defaultSettings);
// HACK we need a way to track where focus and scroll were left on the first loaded page
// but we won't have an entry in history for this initial page, so we just make up a key.
const orInitialKey = (key) => key !== undefined ? key : "initial";
exports.wrapHistory = (history, settingsOverrides) => {
    const settings = Object.assign(Object.assign({}, exports.defaultSettings), settingsOverrides);
    const oafRouter = oaf_routing_1.createOafRouter(settings, location => location.hash);
    const initialLocation = history.location;
    // HACK: We use setTimeout to give React a chance to render before we repair focus.
    setTimeout(() => {
        oafRouter.handleFirstPageLoad(initialLocation);
    }, settings.renderTimeout);
    // tslint:disable-next-line: no-let
    let previousLocation = initialLocation;
    const unlisten = history.listen((location, action) => {
        // We're the first subscribed listener, so the DOM won't have been updated yet.
        oafRouter.handleLocationWillChange(orInitialKey(previousLocation.key), orInitialKey(location.key), action);
        // HACK: We use setTimeout to give React a chance to render before we repair focus.
        const stablePreviousLocation = previousLocation;
        setTimeout(() => {
            oafRouter.handleLocationChanged(stablePreviousLocation, location, orInitialKey(location.key), action);
        }, settings.renderTimeout);
        previousLocation = location;
    });
    return () => {
        oafRouter.resetAutoScrollRestoration();
        unlisten();
    };
};
