import { Action, History, Location, UnregisterCallback } from "history";
import { Selector } from "oaf-side-effects";
import { PageState } from "./page-state";
export interface RouterSettings {
    readonly announcementsDivId: string;
    readonly primaryFocusTarget: Selector;
    readonly documentTitle: (location: Location) => string;
    readonly navigationMessage: (title: string, location: Location, action: Action) => string;
    readonly shouldHandleAction: (previousLocation: Location, nextLocation: Location, action: Action) => boolean;
    readonly disableAutoScrollRestoration: boolean;
    readonly announcePageNavigation: boolean;
    readonly setPageTitle: boolean;
    readonly renderTimeout: number;
    readonly defaultPageState: PageState;
    readonly focusOptions?: FocusOptions;
    readonly scrollIntoViewOptions?: ScrollIntoViewOptions;
}
export declare const defaultSettings: RouterSettings;
export declare const wrapHistory: <A = any>(h: History<A>, s?: Partial<RouterSettings> | undefined) => UnregisterCallback;
